<?php
    $safe = chr(12)."SafePackage".chr(0);
    
    $category = array("none", "basic", "party", "social", "pet", "summon");

    $crystal_type = array("none", "d", "c", "b", "a", "s");
    
    $armor_type = array("0" => "none", "1" => "light", "2" => "heavy", "3" => "magic");

    $material_type = array("1" => "oriharukon", "2" => "mithril", "3" => "gold", "4" => "silver", 
	    "6" => "bronze", "8" => "steel", "13" => "wood", "14" => "bone", "17" => "cloth", "18" => "paper", 
	    "19" => "leather", "23" => "crystal", "33" => "cotton", "37" => "cobweb", "38" => "dyestuff", 
	    "46" => "scale_of_dragon", "47" => "adamantaite", "48" => "blood_steel", "49" => "chrysolite", 
	    "50" => "damascus", "51" => "fine_steel", "52" => "horn", "53" => "liquid");

    $body_part = array("0" => "underwear", "1" => "rear;lear", "3" => "neck", "4" => "rfinger;lfinger", "6" => "head", 
	    "7" => "rhand", "8" => "lhand", "9" => "gloves", "10" => "chest", "11" => "legs", "12" => "feet", 
	    "13" => "back", "14" => "rlhand", "15" => "hair");
	    
    $class_name = array("0" => "Mfighter", "1" => "Ffighter", "2" => "MDarkElf", "3" => "FDarkElf", "4" => "MDwarf", 
	    "5" => "FDwarf", "6" => "MElf", "7" => "FElf", "8" => "MMagic", "9" => "FMagic", "10" => "MOrc", 
	    "11" => "FOrc", "12" => "MShaman", "13" => "FShaman");

    $etcitem_type = array("0" => "none", "1" => "scroll", "2" => "arrow", "3" => "potion", "5" => "recipe",
            "6" => "material", "7" => "pet_collar", "8" => "castle_guard", "9" => "dye", "10" => "seed",
	    "11" => "seed2", "12" => "harvest", "13" => "lotto", "14" => "race_ticket", "15" => "algo");
				    
    $consume_type = array("0" => "consume_type_normal", "2" => "consume_type_stackable", "3" => "consume_type_asset");

	    
    $weapon_type = array("0" => "none", "1" => "sword", "2" => "blunt", "3" => "dagger", "4" => "pole", 
	    "5" => "dualfist", "6" => "bow", "7" => "etc", "8" => "dual");

    
    function array_to_code($array, $nested_level = 0) {
        $code_string = "";
        if (is_array($array)) {
            $code_string .= "array(";
            foreach ($array as $key => $value) {
                $element_code = array_to_code($value, $nested_level + 1);
                $code_string .= "\"".$key."\" => ".$element_code.", ";
            }
            $code_string = substr($code_string, 0, strlen($code_string) - 2).")";
        } else {
            $code_string = "\"".str_replace(array(chr(36), chr(34)), array("\\".chr(36), "\\".chr(34)), $array)."\"";
        }
        return $code_string;
    }

    function endian($fp, $bytes) {
	$num = fread($fp, $bytes--); $rs = "";
	for ($i = $bytes; $i >= 0; $i--) $rs .= sprintf("%02X", ord($num[$i]));
	if ($rs == "FFFFFFFF") return (-1); return hexdec($rs);
    }

    function unendian($num) {
	if ($num == -1) return chr(255).chr(255).chr(255).chr(255);
	while(1) { 
	    $a = ($num / 16); $a = explode(".", $a); if (!isset($a[1])) $a[1] = 0;
	    $num = $a[0]; $a[1] = "0.".$a[1]; $final .= dechex($a[1] * 16); if ($a[0] == 0) break;
	}
	$final = strrev($final); $final = "00000000".$final; $num = substr($final, -8);
	$num1 = substr($num, 0, 2); $num2 = substr($num, 2, 2); $num3 = substr($num, 4, 2); $num4 = substr($num, 6, 2);
	$num = chr(hexdec($num4)).chr(hexdec($num3)).chr(hexdec($num2)).chr(hexdec($num1));
	return $num;
    }

    function readfloat($fp, $bytes = 4) {
	$num = fread($fp, $bytes--); $rs = "";
	for ($i = $bytes; $i >= 0; $i--) $rs .= sprintf("%02X", ord($num[$i]));
	
	$hex1 = hexdec(substr($rs, 0, 2));
	$hex2 = hexdec(substr($rs, 2, 2));
	$hex3 = hexdec(substr($rs, 4, 2));
	$hex4 = hexdec(substr($rs, 6, 2));
	
	$binary = sprintf("%08b%08b%08b%08b", $hex1, $hex2, $hex3, $hex4);
	if ($binary == "00000000000000000000000000000000") return "0";
	
	$sign = substr($binary, 0, 1); $m = substr($binary, 9, 23); $e = bindec(substr($binary, 1, 8)) - 127;
	$num = array(); $num[0] = "1".substr($m, 0, $e); $num[1] = substr($m, $e, strlen($num));
	$d = bindec($num[0]).".".bindec($num[1]); if (floor($d) == $d) $d = floor($d);
	
	if ($sign) return $d * (-1); else return $d;
    }
    
    function writefloat($num) {
	if ($num == 0) return(chr(0).chr(0).chr(0).chr(0));
	$sign = "0"; if ($num[0] == "-") { $num = substr($num, 1, strlen($num)); $sign = "1"; }
	$a = explode(".", $num); $binary = sprintf("%08b", $a[0]); $a[1] = "0.".$a[1];
	$binary = ltrim($binary, "0");
	
	while(1) {
	    $i++; $x = $a[1] * 2; $tmp = explode(".", $x); $final .= $tmp[0];
	    $a[1] = "0.".$tmp[1]; if ($tmp[1] == 0 || $i == 23) break;
	}
	$putazo = sprintf("%08b", (strlen($binary) + 126));
	$binary = substr(str_replace(".", "", ltrim($binary.".".$final, "0")."00000000000000000000000"), 1, 23);
	$lastone = $sign.$putazo.$binary;
	
	for ($i = 0; $i < 32; $i += 4) $rs .= (dechex(bindec(substr($lastone, $i, 4))));
	$hex1 = substr($rs, 6, 2); $hex2 = substr($rs, 4, 2); $hex3 = substr($rs, 2, 2); $hex4 = substr($rs, 0, 2);
	return (chr(hexdec($hex1)).chr(hexdec($hex2)).chr(hexdec($hex3)).chr(hexdec($hex4)));
    }

    
    function readfloat2($fp, $bytes) {
	$num = fread($fp, 1); $trash = fread($fp, 3); 
	$binary = sprintf("%08b", ord($num)); if ($binary == "00000000") return "0";
	
	$sign = substr($binary, 0, 1); $m = "1.".rtrim(substr($binary, 4, 4), "0");
	$e = bindec(substr($binary, 1, 3)) - 3;
	$num = ($m * (pow(10, $e))); $num = explode(".", $num);

	$rs = 0; $a = -1; for ($i = (2 * strlen($num[0])); $i > 0; $i = ($i / 2)) {
	    if ($a == strlen($num[0]) - 1) break; $a++; 
	    $rs += ($i * $num[0][$a]);
	}
	
	$a = -1; for ($i = 0.5; $i > 0; $i = ($i / 2)) {
	    if ($a == strlen($num[1]) - 1) break; $a++; 
	    $rs += ($i * $num[1][$a]);
	}

	if ($sign) $rs *= (-1); if (floor($rs) == $rs) $rs = floor($rs);
	return $rs;
    }

    function makecolor($rgb) {
	$R = substr($rgb, 0, 2); $G = substr($rgb, 2, 2); $B = substr($rgb, 4, 2); 
	return chr(hexdec($B)).chr(hexdec($G)).chr(hexdec($R)).chr(255);
    }

    function textread($fp, $bytes) {
	$len = endian($fp, $bytes);
	if ($bytes == 1) {
	    if ($len >= 64) { 
		$rs = ""; $len2 = 1;
	        $len2 = endian($fp, 1);
	        if ($len2 > 12) { fseek($fp, ftell($fp) - 1); $len2 = 1; }
	        $len = (($len2 * 64) + ($len - 64)); 
	        $rs = fread($fp, 12); fseek($fp, ftell($fp) - 12);
	        if (substr_count($rs, chr(0))) {
		    $rs = ""; while($rs[strlen($rs) - 1] != chr(0)) $rs .= ununicode(fread($fp, 2));
		    return(str_replace("\0", "", $rs));
		}
	    }
	}
	if ($len == 0) return("");
	$rs = fread($fp, $len); return(str_replace("\0", "", $rs));
    }    

    function textwrite($str, $bytes, $cero, $unicode) {
	if ($cero && strlen($str)) $str .= chr(0); $len = strlen($str);
	if ($unicode) { $tmp = ""; for ($i = 0; $i < $len; $i++) $tmp .= $str[$i].chr(0); $str = $tmp; $len *= 2; }
	if ($bytes == 4) {
	    $len = unendian($len);
	    return $len.$str;
	}
	if ($bytes == 1) {
	    if ($len > 63) {
		$a = explode(".", ($len / 64));
		$b = (($len + 64) - ($a[0] * 64));
		$len1 = unendian($b);
		$len2 = unendian($a[0]);
		return $len1[0].$len2[0].$str;
	    } else {
	        $len = unendian($len);
		return $len[0].$str;
	    }
	}
    }

    function ununicode($bytes) {
	if ($bytes[1] != chr(0)) { if (ord($bytes[1]) == 32) return "'"; else return "?"; }
	return $bytes[0];
    }

    function ununicode2($bytes) {
	if ($bytes[1] != chr(0)) return ""; return $bytes[0];
    }
    
    function ffwrite($fp, $data) {
	for ($i = 0; $i < strlen($data); $i++) fwrite($fp, $data[$i].chr(0), 2);
    }

    function makesname($name) {
	$name = strtolower($name);
	$delete = array("& ", "- ", "~ ", ":", "(", ")", "<", ">", "'", ",", ".", "%", "?");
	$replace = array(" ", "-", "+", "/", "*", "__", "___", "____");
	$name = str_replace($delete, "", $name);
	$name = str_replace($replace, "_", $name);
	$name = trim($name, " _");
	return($name);
    }
?>
